class_name Raquette
extends StaticBody2D


const VITESSE_MAX: float = 20.0

var _vitesse: float = 0.0


func _physics_process(_delta: float) -> void:
	if not est_vivant():
		return
	position.x += _vitesse


func _unhandled_input(evenement: InputEvent) -> void:
	if not est_vivant():
		return
	if evenement is InputEventMouseMotion:
		_bouger_avec_souris(evenement)
	elif evenement is InputEventKey:
		_bouger_avec_clavier(evenement)


func est_vivant() -> bool:
	return true


func _bouger_avec_souris(evenement_souris: InputEventMouseMotion) -> void:
	position.x = evenement_souris.get_position().x


func _bouger_avec_clavier(evenement_clavier: InputEventKey) -> void:
	if evenement_clavier.is_action_pressed("bouger_a_droite"):
		_vitesse = VITESSE_MAX
	elif evenement_clavier.is_action_pressed("bouger_a_gauche"):
		_vitesse = -VITESSE_MAX
	if evenement_clavier.is_released() and (evenement_clavier.is_action("bouger_a_gauche") or evenement_clavier.is_action("bouger_a_droite")) :
		_vitesse = 0.0
